function [regns] = branch(regn)
% Author: Yang Qi, Department of Biochemistry and Department of Computer
%         Science, Duke University
%
% branch function for legal regions
% input: a region(3x2 matrix)
% output: branched regions(3x2x(m^3) matrix)

m = 2; %m^3: number of divided regions

regns = zeros(3,2,m^3); % matrix to store all regions

for i = 1:m^3
    %branch
    if ceil(i/m^2)==1
        regns(1,:,i)= [regn(1,1),mean(regn(1,:))];
    else
        regns(1,:,i)= [mean(regn(1,:)),regn(1,2)];
    end
    if mod(ceil(i/m),2)==1 
        regns(2,:,i)= [regn(2,1),mean(regn(2,:))];
    else
        regns(2,:,i)= [mean(regn(2,:)),regn(2,2)];
    end
    if mod(i,2)==1
        regns(3,:,i)= [regn(3,1),mean(regn(3,:))];
    else
        regns(3,:,i)= [mean(regn(3,:)),regn(3,2)];
    end
end

end