function [regns, iregns] = iBranch(iregn)
% Author: Yang Qi, Department of Biochemistry and Department of Computer
%         Science, Duke University
%
% branch function for illegal regions
% input: a region(3x2 matrix)
% output: branched regions(3x2x(m^3) matrix)

m = 2; %m^3: number of divided regions

aregns = zeros(3,2,m^3); % matrix to store all regions
regns = zeros(3,2,0);
iregns = zeros(3,2,0);
j = 1; % initial index for legal regions
k = 1; % initial index for illegal regions

for i = 1:m^3
    %branch
    if ceil(i/m^2)==1
        aregns(1,:,i)= [iregn(1,1),mean(iregn(1,:))];
    else
        aregns(1,:,i)= [mean(iregn(1,:)),iregn(1,2)];
    end
    if mod(ceil(i/m),2)==1 
        aregns(2,:,i)= [iregn(2,1),mean(iregn(2,:))];
    else
        aregns(2,:,i)= [mean(iregn(2,:)),iregn(2,2)];
    end
    if mod(i,2)==1
        aregns(3,:,i)= [iregn(3,1),mean(iregn(3,:))];
    else
        aregns(3,:,i)= [mean(iregn(3,:)),iregn(3,2)];
    end
    
    %classify
    %legal regions
    if -sum(aregns(:,2,i))>aregns(3,2,i) && aregns(3,1,i)>aregns(2,2,i) && aregns(2,1,i)>aregns(1,2,i)
        regns(:,:,j) = aregns(:,:,i);
        j = j+1;
    %disallowed regions -> pruned
    elseif -sum(aregns(:,1,i))<=aregns(3,1,i) || aregns(3,2,i)<=aregns(2,1,i) || aregns(2,2,i)<=aregns(1,1,i)
    %illegal regions
    else
        iregns(:,:,k) = aregns(:,:,i);
        k = k+1;
    end
end

end