function [qua] = ijk2qua(i,j,k,lvl)
% Author: Yang Qi, Department of Biochemistry and Department of Computer
%         Science, Duke University
%
% convert indice i,j,k to a quaternion
% input: indice i,j,k and the index level lvl
% output: the corresponding quaternion

ni = 12*2^lvl;
nj = 24*2^lvl;
nk = 24*2^lvl;

theR = pi*(i-1)/ni;
phiR = 2*pi*(j-1)/nj;
psiR = 2*pi*(k-1)/nk-pi;
qua = [cos(theR/2)*cos(psiR/2),cos(theR/2)*sin(psiR/2),sin(theR/2)*cos(phiR+psiR/2),sin(theR/2)*sin(phiR+psiR/2)];
end