function [objVal] = objFunc(s1,s2,mQave,quaL,quaR)
% Author: Yang Qi, Department of Biochemistry and Department of Computer
%         Science, Duke University
%
% the least-square objective function for the fitting process
% input: saupe tensor arrays (s1, s2), the averaging Q matrix Qave,
%        quaternion of the left rotation quaL, quaternion of the right
%        rotation quaR
%        quaL and quaR are NOT the same quaL and quaR in the output!
% output: the value of the objective function objVal

QR = calQm(quaR);
QL = calQm(quaL);
s2p = QL*mQave*QR*s1;

objVal = sumsqr(s2p-s2);
end