function [sm] = v2m(sv)
% Author: Yang Qi, Department of Biochemistry and Department of Computer
%         Science, Duke University
%
% convert vectorized Saupe tensors back into matrices
% input: a 5xNs matrix containing Ns vectorized Saupe tensors
%        vectorized Saupe tensors in the form of [Sxx,Syy,Sxy,Sxz,Syz]
% output: a 3x3xNs matrix containing Ns Saupe tensors

Ns = size(sv,2);
sm = zeros(3,3,Ns);
for i = 1:Ns
    sm(:,:,i) = [sv(1,i),sv(3,i),sv(4,i);
        sv(3,i),sv(2,i),sv(5,i);
        sv(4,i),sv(5,i),-sv(1,i)-sv(2,i)];
end
end